﻿Type=Activity
Version=6.8
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	Private cu As ContactsUtils
	Private index As Object
	Private contacts As List
End Sub

Sub Globals
	Dim sv As SearchView
End Sub

Sub Activity_Create(FirstTime As Boolean)
	sv.Initialize(Me, "sv")
	Dim items As List
	items.Initialize
	If FirstTime Then
		cu.Initialize
		
		contacts.Initialize
		
		ProgressDialogShow("Building contacts index...")
		Dim allcontacts As List= cu.FindAllContacts(True)
		allcontacts.SortType("DisplayName",True)
		For Each c As cuContact In allcontacts
			DoEvents
			Dim it As Item
			it.Title = c.DisplayName
			it.SearchText = c.DisplayName.ToLowerCase
			Dim mobile As Boolean=False
			If c.Id <0 Then
				Dim no() As  String
				no=Regex.Split(":",c.DisplayName)
				c.DisplayName=no(0)
				it.Text=no(1)
				it.Title=no(0)
				it.SearchText=no(0) & " " & no(1)
				c.phoneNo=no(1)
				it.Value=c
				
			Else
			  For Each phone As cuPhone In cu.GetPhones(c.Id)
			'	If phone.PhoneType="mobile" Then   ' if uncommented shows only mobiles
				   it.Text = phone.Number
				   it.SearchText = it.SearchText & " " & CleanPhone(phone.Number)
				   it.Value = c
			'	End If
			  Next
			End If
			contacts.Add(it)
			'contacts.Sort(True)
		Next
		index = sv.SetItems(contacts)
		ProgressDialogHide
	Else
		sv.SetIndex(index, contacts) 'reuse the data we collected
	End If
	sv.AddToParent(Activity, 10dip, 10dip, 100%x - 10dip, 300dip)
End Sub

Sub CleanPhone(n As String) As String
	Dim sb As StringBuilder
	sb.Initialize
	For i = 0 To n.Length - 1
		Dim ascValue As Int = Asc(n.CharAt(i))
		If ascValue >= 48 And ascValue <= 57 Then
			sb.Append(n.CharAt(i))
		End If
	Next
	Return sb.ToString
End Sub

Sub sv_ItemClick (contact As Object)
	Dim c As cuContact = contact
	Dim ph As cuPhone
	ph.Initialize
	If c.Id>0 Then
	  Dim tel As List=cu.GetPhones(c.Id)
	Else  
		CallSubDelayed2(Main,"setphone",c.phoneNo)
		Activity.Finish
		Return
	End If
	
	For Each tl In tel
		ph=tl
		If ph.PhoneType="mobile" Then ' mobile
			CallSubDelayed2(Main,"setphone",ph.Number)
			Activity.Finish
			Return 
		End If
    Next
End Sub

Sub Activity_Resume
    
End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub


